#include <GDIPlus.au3>
#include <GuiConstantsEx.au3>
#include <WindowsConstants.au3>
#include <Sound.au3>

Global $MainX = 1024, $MainY = 720, $Sleep = 50, $WMin = 10, $WMax = 20

While $MainX > @DesktopWidth Or $MainY > @DesktopHeight
	$MainX *= 0.9
	$MainY *= 0.9
WEnd

_GDIPlus_Startup()

Global $aFeld[75][6];0=Kegelfarbe,1=Ringfarbe,2=X,3=Y,4=W,5=H

Global $hWOF = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WOF.png")
Global $hFOF = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\FOF.png")
Global $hFOA = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\FOA.png")
Global $hFOI = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\FOI.png")
Global $hHGK = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HGK.png")
Global $hHGO = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HGO.png")
Global $hHBK = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HBK.png")
Global $hHBO = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HBO.png")
Global $hHRK = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HRK.png")
Global $hHRO = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HRO.png")
Global $hHYK = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HYK.png")
Global $hHYO = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\HYO.png")
Global $hKGA = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KGA.png")
Global $hKGI = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KGI.png")
Global $hKBA = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KBA.png")
Global $hKBI = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KBI.png")
Global $hKRA = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KRA.png")
Global $hKRI = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KRI.png")
Global $hKYA = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KYA.png")
Global $hKYI = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\KYI.png")
Global $hOTG = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\OTG.png")
Global $hOTB = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\OTB.png")
Global $hOTR = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\OTR.png")
Global $hOTY = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\OTY.png")
Global $hWF1 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF1.png")
Global $hWF2 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF2.png")
Global $hWF3 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF3.png")
Global $hWF4 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF4.png")
Global $hWF5 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF5.png")
Global $hWF6 = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\WF6.png")
Global $hPLF = _GDIPlus_BitmapCreateFromFile(@ScriptDir & "\GFX\PLF.png")
Global $SND1 = _SoundOpen(@ScriptDir & "\SFX\1.wav")
Global $SND2 = _SoundOpen(@ScriptDir & "\SFX\2.wav")
Global $SND3 = _SoundOpen(@ScriptDir & "\SFX\3.wav")
Global $SND4 = _SoundOpen(@ScriptDir & "\SFX\4.wav")
Global $SND5 = _SoundOpen(@ScriptDir & "\SFX\5.wav")
Global $SND6 = _SoundOpen(@ScriptDir & "\SFX\6.wav")

Global $LetzterWurf = 6, $Reihenfolge = 1, $FigurPos[5][5], $msg, $Timer = TimerInit(), $Flash = False, $Erfolgreich = 0, $Geschmissen = False
_InitializeFields()



$hGUI = GUICreate("Mensch rgere dich nicht", $MainX, $MainY)
Global $hBackGround = _GDIPlus_GraphicsCreateFromHWND($hGUI)
$hWuerfel = GUICtrlCreateLabel("", $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
;GUISetBkColor(0x000000)
_CreateEmty()
GUIRegisterMsg($WM_PAINT, '_Redraw')
GUISetState()
_LoadBackground()

Sleep(2000)
_UpdateBackground()
_SoundPlay($SND2, 1)

Do
	;If $Reihenfolge=1 Then $Reihenfolge=2
	If $Reihenfolge = 1 Then
		$msg = GUIGetMsg()
		If $msg = $hWuerfel Then
			$LetzterWurf = _Wuerfeln()
			$Erfolgreich = _Spielzug()
			If $LetzterWurf <> 6 Or $Erfolgreich = 0 Then $Reihenfolge = 2
			
			$aFeld[73][1] = $Reihenfolge + 5
			If $Erfolgreich = 0 Then _SoundPlay($SND4, 1)
			_UpdateBackground()
			If $Erfolgreich = 1 Then _SoundPlay($SND3, 1)
			If $Geschmissen = True Then
				_SoundPlay($SND5, 0)
				$Geschmissen = False
			EndIf
			Sleep($Sleep * 10)
		EndIf
		
		If $Flash = False And TimerDiff($Timer) > 80 Then
			$Timer = TimerInit()
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $hOTG, $aFeld[73][2] + 1, $aFeld[73][3] + 1, $aFeld[73][4] - 2, $aFeld[73][5] - 2)
			_GDIPlus_GraphicsDrawImageRect($hBackGround, Eval("hWF" & $LetzterWurf), $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
			If $aFeld[44][0] = 1 Then _GDIPlus_GraphicsDrawImageRect($hBackGround, $hHGK, $aFeld[44][2], $aFeld[44][3], $aFeld[44][4], $aFeld[44][5])
			$Flash = True
		EndIf
		
		If $Flash = True And TimerDiff($Timer) > 200 Then
			$Timer = TimerInit()
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $hOTG, $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
			_GDIPlus_GraphicsDrawImageRect($hBackGround, Eval("hWF" & $LetzterWurf), $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
			If $aFeld[44][0] = 1 Then _GDIPlus_GraphicsDrawImageRect($hBackGround, $hHGK, $aFeld[44][2], $aFeld[44][3], $aFeld[44][4], $aFeld[44][5])
			$Flash = False
		EndIf
		
	EndIf
	
	
	_checkwinner()
	
	If $Reihenfolge > 1 Then
		;BlockInput(1)
		$LetzterWurf = _Wuerfeln_Comp()
		$Erfolgreich = _Spielzug_Comp()
		If $LetzterWurf <> 6 Or $Erfolgreich = 0 Then $Reihenfolge += 1
		If $Reihenfolge > 4 Then $Reihenfolge = 1
		If $Reihenfolge = 1 Then
			Do
			Until GUIGetMsg() = 0
		EndIf
		$aFeld[73][1] = $Reihenfolge + 5
		;Sleep($Sleep*5)
		If $Erfolgreich = 0 Then _SoundPlay($SND4, 1)
		_UpdateBackground()
		If $Erfolgreich = 1 Then _SoundPlay($SND3, 1)
		If $Geschmissen = True Then
			_SoundPlay($SND5, 0)
			$Geschmissen = False
		EndIf
		;BlockInput(0)
	EndIf
	
Until $msg = $GUI_EVENT_CLOSE
_GDIPlus_Shutdown()


Func _Spielzug()
	Local $Spielzug = _Moeglich(), $msg, $Timer = TimerInit(), $Flash = False, $Count = 1, $Image
	If $Spielzug[0][0] = 0 Then Return 0
	While 1
		If $Flash = False And TimerDiff($Timer) > 100 Then
			$Timer = TimerInit()
			$Image = _SelectImage($aFeld[$Spielzug[$Count][0]][0], $aFeld[$Spielzug[$Count][0]][1])
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$Spielzug[$Count][0]][2], $aFeld[$Spielzug[$Count][0]][3], $aFeld[$Spielzug[$Count][0]][4] + 2, $aFeld[$Spielzug[$Count][0]][5] + 2)
			$Image = _SelectImage($aFeld[$Spielzug[$Count][1]][0], $aFeld[$Spielzug[$Count][1]][1])
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$Spielzug[$Count][1]][2], $aFeld[$Spielzug[$Count][1]][3], $aFeld[$Spielzug[$Count][1]][4] + 2, $aFeld[$Spielzug[$Count][1]][5] + 2)
			$Flash = True
		EndIf
		If $Flash = True And TimerDiff($Timer) > 100 Then
			$Timer = TimerInit()
			$Image = _SelectImage($aFeld[$Spielzug[$Count][0]][0], $aFeld[$Spielzug[$Count][0]][1])
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$Spielzug[$Count][0]][2], $aFeld[$Spielzug[$Count][0]][3], $aFeld[$Spielzug[$Count][0]][4], $aFeld[$Spielzug[$Count][0]][5])
			$Image = _SelectImage($aFeld[$Spielzug[$Count][1]][0], $aFeld[$Spielzug[$Count][1]][1])
			_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$Spielzug[$Count][1]][2], $aFeld[$Spielzug[$Count][1]][3], $aFeld[$Spielzug[$Count][1]][4], $aFeld[$Spielzug[$Count][1]][5])
			$Flash = False
			$Count += 1
			If $Count > $Spielzug[0][0] Then $Count = 1
		EndIf
		$msg = GUIGetCursorInfo()
		If $msg[2] = 1 Then
			For $i = 1 To $Spielzug[0][0]
				If _GetPos($msg[0], $msg[1], $aFeld[$Spielzug[$i][0]][2] + $aFeld[$Spielzug[$i][0]][4] / 2, $aFeld[$Spielzug[$i][0]][3] + $aFeld[$Spielzug[$i][0]][5] / 2) = 1 Then
					If $aFeld[$Spielzug[$i][0]][0] <> 0 Then _Schmeissen($aFeld[$Spielzug[$i][0]][0], $Spielzug[$i][0])
					$aFeld[$Spielzug[$i][0]][0] = $Reihenfolge
					$aFeld[$Spielzug[$i][1]][0] = 0
					$FigurPos[$Reihenfolge][$Spielzug[$i][2]] = $Spielzug[$i][0]
					Return 1
				EndIf
			Next
		EndIf
	WEnd
	Return 1
EndFunc   ;==>_Spielzug

Func _GetPos($X, $Y, $a, $b)
	Local $Offset = 30
	If $X > $a - $Offset And $X < $a + $Offset And $Y > $b - $Offset And $Y < $b + $Offset Then
		Return 1
	Else
		Return 0
	EndIf
EndFunc   ;==>_GetPos


Func _Spielzug_Comp()
	Local $Spielzug = _Moeglich(), $i
	If $Spielzug[0][0] = 0 Then Return 0
	For $i = 1 To $Spielzug[0][0]
		;MsgBox(0,$Reihenfolge,$Spielzug[1][1] & @CRLF & $Spielzug[1][0])
		_Flashfields($Spielzug[1][0], $Spielzug[1][1])
		If $aFeld[$Spielzug[1][0]][0] <> 0 Then _Schmeissen($aFeld[$Spielzug[1][0]][0], $Spielzug[1][0])
		$aFeld[$Spielzug[1][0]][0] = $Reihenfolge
		$aFeld[$Spielzug[1][1]][0] = 0
		$FigurPos[$Reihenfolge][$Spielzug[1][2]] = $Spielzug[1][0]
		ExitLoop
	Next
	Return 1
EndFunc   ;==>_Spielzug_Comp


Func _Moeglich()
	Local $Return[1][3], $Count = 0, $Feld, $i, $Runde
	$Return[0][0] = 0
	If $LetzterWurf = 6 And $aFeld[$Reihenfolge * 10 - 9][0] <> $Reihenfolge And _GetHome() <> 0 Then
		$Count += 1
		ReDim $Return[$Count + 1][3]
		$Return[$Count][0] = $Reihenfolge * 10 - 9
		$Return[$Count][1] = _GetHome()
		$Return[$Count][2] = @extended
	EndIf
	For $i = 1 To 4
		$Runde = True
		$Feld = $FigurPos[$Reihenfolge][$i] + $LetzterWurf
		If $Reihenfolge = 2 And $Feld > 10 And $FigurPos[$Reihenfolge][$i] <= 10 Then
			$Feld = $Feld - 10 + 44
			$Runde = False
		ElseIf $Reihenfolge = 3 And $Feld > 20 And $FigurPos[$Reihenfolge][$i] <= 20 Then
			$Feld = $Feld - 20 + 48
			$Runde = False
		ElseIf $Reihenfolge = 4 And $Feld > 30 And $FigurPos[$Reihenfolge][$i] <= 30 Then
			$Feld = $Feld - 30 + 52
			$Runde = False
		EndIf
		
		If $FigurPos[$Reihenfolge][$i] > 56 Then
			ContinueLoop
		ElseIf $Reihenfolge = 1 And $Feld > 44 Then
			ContinueLoop
		ElseIf $Reihenfolge = 2 And $Feld > 48 Then
			ContinueLoop
		ElseIf $Reihenfolge = 3 And $Feld > 52 Then
			ContinueLoop
		ElseIf $Reihenfolge = 4 And $Feld > 56 Then
			ContinueLoop
		ElseIf $Reihenfolge <> 1 And $Feld > 40 And $FigurPos[$Reihenfolge][$i] <= 40 And $Runde = True Then
			$Feld -= 40
		EndIf
		If $aFeld[$Feld][0] <> $Reihenfolge Then
			$Count += 1
			ReDim $Return[$Count + 1][3]
			$Return[$Count][0] = $Feld
			$Return[$Count][1] = $FigurPos[$Reihenfolge][$i]
			$Return[$Count][2] = $i
		EndIf
	Next
	$Return[0][0] = $Count
	Return $Return
EndFunc   ;==>_Moeglich

Func _Schmeissen($Wer, $Feld)
	Local $i
	For $i = 1 To 4
		If $FigurPos[$Wer][$i] = $Feld Then
			$FigurPos[$Wer][$i] = _GetHomeFree($Wer)
			$aFeld[$FigurPos[$Wer][$i]][0] = $Wer
			$Geschmissen = True
			ExitLoop
		EndIf
	Next
EndFunc   ;==>_Schmeissen

Func _GetHomeFree($Wer)
	Local $i
	For $i = 1 To 4
		If $aFeld[$Wer * 4 + $i + 52][0] = 0 Then Return $Wer * 4 + $i + 52
	Next
	Return 0
EndFunc   ;==>_GetHomeFree


Func _GetHome()
	Local $i
	SetExtended(0)
	For $i = 1 To 4
		If $FigurPos[$Reihenfolge][$i] > 56 Then
			SetExtended($i)
			Return $FigurPos[$Reihenfolge][$i]
		EndIf
	Next
	Return 0
EndFunc   ;==>_GetHome

Func _Wuerfeln()
	Local $msg, $Zahl
	Do
		$msg = GUIGetCursorInfo($hGUI)
		$Zahl = Random(5, 6, 1)
		If $Zahl<>6 Then $Zahl = Random(1, 6, 1)
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $hOTG, $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
		If $aFeld[44][0] = 1 Then _GDIPlus_GraphicsDrawImageRect($hBackGround, $hHGK, $aFeld[44][2], $aFeld[44][3], $aFeld[44][4], $aFeld[44][5])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, Eval("hWF" & $Zahl), $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
		_SoundPlay($SND1, 0)
		Sleep(20)
	Until $msg[4] <> $hWuerfel Or $msg[2] = 0
	Return $Zahl
EndFunc   ;==>_Wuerfeln

Func _Wuerfeln_Comp()
	Local $Zahl, $i, $Img = $hOTB
	If $Reihenfolge = 3 Then $Img = $hOTR
	If $Reihenfolge = 4 Then $Img = $hOTY
	For $i = 1 To Random($WMin, $WMax, 1)
		$Zahl = Random(1, 6, 1)
		;If $Zahl=6 Then $Zahl = Random(1, 6, 1)
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $Img, $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
		If $aFeld[44][0] = 1 Then _GDIPlus_GraphicsDrawImageRect($hBackGround, $hHGK, $aFeld[44][2], $aFeld[44][3], $aFeld[44][4], $aFeld[44][5])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, Eval("hWF" & $Zahl), $aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5])
		_SoundPlay($SND1, 0)
		Sleep(20)
	Next
	Return $Zahl
EndFunc   ;==>_Wuerfeln_Comp

Func _Flashfields($F1, $F2)
	Local $i, $Image
	For $i = 1 To 5
		$Image = _SelectImage($aFeld[$F1][0], $aFeld[$F1][1])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$F1][2], $aFeld[$F1][3], $aFeld[$F1][4] + 2, $aFeld[$F1][5] + 2)
		$Image = _SelectImage($aFeld[$F2][0], $aFeld[$F2][1])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$F2][2], $aFeld[$F2][3], $aFeld[$F2][4] + 2, $aFeld[$F2][5] + 2)
		Sleep($Sleep)
		$Image = _SelectImage($aFeld[$F1][0], $aFeld[$F1][1])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$F1][2], $aFeld[$F1][3], $aFeld[$F1][4], $aFeld[$F1][5])
		$Image = _SelectImage($aFeld[$F2][0], $aFeld[$F2][1])
		_GDIPlus_GraphicsDrawImageRect($hBackGround, $Image, $aFeld[$F2][2], $aFeld[$F2][3], $aFeld[$F2][4], $aFeld[$F2][5])
		Sleep($Sleep)
	Next
EndFunc   ;==>_Flashfields


Func _InitializeFields()
	Local $X_POS, $Y_POS, $X_Mid, $Y_Mid, $Fakx, $Faky, $i, $j, $k
	Local $FX = $MainX / 1024, $FY = $MainY / 720
	Local $OffsetX = 150 * $FX
	Local $OffsetY = 65 * $FY
	;MsgBox(0,"init",$FX & " " & $FY)
	;Exit
	$X_Mid = IniRead(@ScriptDir & "\GFX\Pos.ini", "X", 73, 0) * $FX - $OffsetX
	$Y_Mid = IniRead(@ScriptDir & "\GFX\Pos.ini", "Y", 73, 0) * $FY - $OffsetY
	For $i = 1 To 73
		$X_POS = IniRead(@ScriptDir & "\GFX\Pos.ini", "X", $i, 0) * $FX - $OffsetX
		$Y_POS = IniRead(@ScriptDir & "\GFX\Pos.ini", "Y", $i, 0) * $FY - $OffsetY
		$Fakx = $FX * 0.8 - ($Y_Mid - $Y_POS) / 800 + ($X_Mid - $X_POS) / 4000
		$Faky = $FY * 0.8 - ($Y_Mid - $Y_POS) / 800; - ($X_Mid - $X_POS) / 4000
		Select
			Case $i = 1 Or ($i > 40 And $i <= 44)
				$aFeld[$i][1] = 1
				$aFeld[$i][0] = 0
			Case $i = 11 Or ($i > 44 And $i <= 48)
				$aFeld[$i][1] = 2
				$aFeld[$i][0] = 0
			Case $i = 21 Or ($i > 48 And $i <= 52)
				$aFeld[$i][1] = 3
				$aFeld[$i][0] = 0
			Case $i = 31 Or ($i > 52 And $i <= 56)
				$aFeld[$i][1] = 4
				$aFeld[$i][0] = 0
			Case $i > 56 And $i <= 60
				$aFeld[$i][1] = 1
				$aFeld[$i][0] = 1
			Case $i > 60 And $i <= 64
				$aFeld[$i][1] = 2
				$aFeld[$i][0] = 2
			Case $i > 64 And $i <= 68
				$aFeld[$i][1] = 3
				$aFeld[$i][0] = 3
			Case $i > 68 And $i <= 72
				$aFeld[$i][1] = 4
				$aFeld[$i][0] = 4
			Case $i = 73
				$aFeld[$i][1] = 6
				$aFeld[$i][0] = 6
			Case Else
				$aFeld[$i][1] = 0
				$aFeld[$i][1] = 0
		EndSelect
		$aFeld[$i][2] = $X_POS - 50 * $Fakx
		$aFeld[$i][3] = $Y_POS - 50 * $Faky
		$aFeld[$i][4] = 100 * $Fakx
		$aFeld[$i][5] = 100 * $Faky
	Next
	$k = 57
	For $i = 1 To 4
		For $j = 1 To 4
			$FigurPos[$i][$j] = $k
			$k += 1
		Next
	Next
EndFunc   ;==>_InitializeFields


Func _UpdateBackground()
	;Local $FX=$MainX/1024, $FY=$MainY/720
	Local $hImage = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\GFX\PLF.png")
	Local $hGraphics = _GDIPlus_ImageGetGraphicsContext($hImage)
	_GDIPlus_GraphicsDrawImageRectRect($hGraphics, $hPLF, 0, 0, 1024, 720, 0, 0, $MainX, $MainY)
	Local $hClone = _GDIPlus_BitmapCloneArea($hImage, 0, 0, $MainX, $MainY, $GDIP_PXF24RGB)
	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_GraphicsDispose($hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($hClone)
	For $i = 21 To 30
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 53 To 56
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 31 To 39
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	_ImageAdd($aFeld[20][2], $aFeld[20][3], $aFeld[20][4], $aFeld[20][5], $aFeld[20][0], $aFeld[20][1], $hGraphics)
	For $i = 49 To 52
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	_ImageAdd($aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5], $aFeld[73][0], $aFeld[73][1], $hGraphics);Wrfelrand
	_ImageAdd($aFeld[73][2], $aFeld[73][3], $aFeld[73][4], $aFeld[73][5], 10, $LetzterWurf, $hGraphics);Wrfelzahl
	For $i = 44 To 41 Step -1
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	_ImageAdd($aFeld[40][2], $aFeld[40][3], $aFeld[40][4], $aFeld[40][5], $aFeld[40][0], $aFeld[40][1], $hGraphics)
	For $i = 19 To 10 Step -1
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 48 To 45 Step -1
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 5 To 9
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 4 To 1 Step -1
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	For $i = 56 To 72
		_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], $aFeld[$i][0], $aFeld[$i][1], $hGraphics)
	Next
	_GDIPlus_ImageSaveToFile($hClone, @TempDir & "\Ludo.bmp")
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_ImageDispose($hClone)
	;_WinAPI_DeleteObject($hImage)
	_LoadBackground()
EndFunc   ;==>_UpdateBackground



Func _CreateEmty()
	Local $hImage = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\GFX\PLF.png")
	Local $hGraphics = _GDIPlus_ImageGetGraphicsContext($hImage)
	_GDIPlus_GraphicsDrawImageRectRect($hGraphics, $hPLF, 0, 0, 1024, 720, 0, 0, $MainX, $MainY)
	Local $hClone = _GDIPlus_BitmapCloneArea($hImage, 0, 0, $MainX, $MainY, $GDIP_PXF24RGB)
	_GDIPlus_ImageDispose($hImage)
	_GDIPlus_GraphicsDispose($hGraphics)
	$hGraphics = _GDIPlus_ImageGetGraphicsContext($hClone)
	For $i = 1 To 73
		If $i = 73 Then
			_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], 5, 5, $hGraphics)
		Else
			_ImageAdd($aFeld[$i][2], $aFeld[$i][3], $aFeld[$i][4], $aFeld[$i][5], 11, 11, $hGraphics)
		EndIf
	Next
	_GDIPlus_ImageSaveToFile($hClone, @TempDir & "\Ludo.bmp")
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_ImageDispose($hClone)
	;_WinAPI_DeleteObject($hImage)
	_LoadBackground()
EndFunc   ;==>_CreateEmty

Func _ImageAdd($X, $Y, $W, $H, $k, $R, $i)
	Local $Image = _SelectImage($k, $R)
	_GDIPlus_GraphicsDrawImageRect($i, $Image, $X, $Y, $W, $H)
EndFunc   ;==>_ImageAdd

Func _SelectImage($k, $R)
	Local $Image
	Select
		Case $k = 0 And $R = 0
			$Image = $hFOI
		Case $k = 1 And $R = 0
			$Image = $hKGI
		Case $k = 2 And $R = 0
			$Image = $hKBI
		Case $k = 3 And $R = 0
			$Image = $hKRI
		Case $k = 4 And $R = 0
			$Image = $hKYI
		Case $k = 1 And $R = 1
			$Image = $hKGA
		Case $k = 2 And $R = 1
			$Image = $hKBA
		Case $k = 3 And $R = 1
			$Image = $hKRA
		Case $k = 4 And $R = 1
			$Image = $hKYA
		Case $k = 0 And $R = 1
			$Image = $hHGO
		Case $k = 0 And $R = 2
			$Image = $hHBO
		Case $k = 0 And $R = 3
			$Image = $hHRO
		Case $k = 0 And $R = 4
			$Image = $hHYO
		Case $k = 2 And $R = 2
			$Image = $hHBK
		Case $k = 3 And $R = 3
			$Image = $hHRK
		Case $k = 4 And $R = 4
			$Image = $hHYK
		Case $R = 5 And $k <> 10
			$Image = $hWOF
		Case $R = 6 And $k <> 10
			$Image = $hOTG
		Case $R = 7
			$Image = $hOTB
		Case $R = 8
			$Image = $hOTR
		Case $R = 9
			$Image = $hOTY
		Case $k = 10
			$Image = Eval("hWF" & $R)
		Case $k = 1
			$Image = $hKGI
		Case $k = 2 And $R > 1
			$Image = $hKBI
		Case $k = 3 And $R > 1
			$Image = $hKRI
		Case $k = 4 And $R > 1
			$Image = $hKYI
		Case Else
			$Image = $hFOF
	EndSelect
	Return $Image
EndFunc   ;==>_SelectImage

Func _Redraw($hwnd, $msg, $wparam, $lparam)
	_LoadBackground()
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_Redraw


Func _LoadBackground()
	Local $hBitmap = _GDIPlus_BitmapCreateFromFile(@TempDir & "\Ludo.bmp")
	_GDIPlus_GraphicsDrawImageRect($hBackGround, $hBitmap, 0, 0, $MainX, $MainY)
	_GDIPlus_ImageDispose($hBitmap)
	;_WinAPI_DeleteObject ($hBitmap)
EndFunc   ;==>_LoadBackground

Func _checkwinner()
	Local $i
	For $i = 1 To 4
		If $aFeld[37 + $i * 4][0] = $i And $aFeld[38 + $i * 4][0] = $i And $aFeld[39 + $i * 4][0] = $i And $aFeld[40 + $i * 4][0] = $i Then
			_SoundPlay($SND6, 0)
			MsgBox(0, "Spiel zu Ende", "Player " & $i & " hat gewonnen...")
			Exit
		EndIf
	Next
EndFunc   ;==>_checkwinner